import java.io.*;

class Museum {

  private static int bestand;
  private static int ausleihzahl;

  Museum (int b)
    {bestand = b; ausleihzahl = 0;}

  synchronized void ausleihe (int s, int n) {
    System.out.println("Schalter " + s + " benoetigt " + n);
    while (bestand < n)
      try
        {wait();}
      catch(InterruptedException e) {}
    bestand = bestand - n;
    ausleihzahl = ausleihzahl + n;
    System.out.println("Schalter " + s + " bekommt " + n);
    System.out.println("Vorhanden: " + bestand +
                       ", ausgeliehen: " + ausleihzahl);
    notifyAll();
    } // Ende Ausleihe

  synchronized void rckgabe (int n) {
    System.out.println("Zurueckgegeben: " + n);
    bestand = bestand + n;
    ausleihzahl = ausleihzahl - n;
    notifyAll();
    } // Ende Rckgabe

  } // Ende Museum

class Schalter extends Thread {

  Museum museum;
  int    nummer;

  static int zufall (int x)
    {return (int) (Math.random() * x + 1);}

  Schalter (Museum m, int n)
    {museum = m; nummer = n;}

  public void run() {
    while(true) {
      int besucherzahl = zufall(10);
      museum.ausleihe(nummer, besucherzahl);
      new Besucher(museum, besucherzahl).start();
      try
        {sleep(zufall(10000));}
      catch(InterruptedException e) {}
      } // Ende while
    } // Ende run

  } // Ende Schalter

class Besucher extends Thread {

  Museum museum;
  int    anzahl;

  Besucher (Museum m, int a)
    {museum = m; anzahl = a;}

  public void run() {
    try
      {sleep((int) Math.random() * 10000 + 1);}
    catch(InterruptedException e) {}
    museum.rckgabe(anzahl);
    } // Ende run

  } // Ende Besucher

class Verleih {

  static int kassettenzahl;
  static int schalterZahl;

  public static void main (String[] eingabe) {

    if (eingabe.length >= 1)
      kassettenzahl = Integer.parseInt(eingabe[0]);
    else
      kassettenzahl = 20;

    Museum m = new Museum(kassettenzahl);

    if (eingabe.length >= 2)
      schalterZahl = Integer.parseInt(eingabe[1]);
    else
      schalterZahl = 3;

    for (int i = 0; i < schalterZahl; i++)
      new Schalter(m, i + 1).start();

    } // Ende main

  } // Ende Verleih